module Operations.Query where

import Data.Query

import Control.Monad.Buuka
import Control.Monad.Reader

import Data.Foldable
       (traverse_)

import Data.Buuka
       (Buuka)
import qualified Data.Buuka as B

import Operations.Format

query :: Field String -> String -> BuukaM ()
query field q =
  buukaQ (asks go) >>= traverse_ (liftIO . putStrLn)
  where
    go :: Buuka -> [String]
    go b = formatEntries b (filter (predicate (regex field q)) . B.elements $ b)

